/*
 * Main.java
 *
 * Created on 15. Juni 2006, 12:13
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import com.imsl.math.*;

/**
 *
 * @author Yves Radunz
 */
public class Main {
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws com.imsl.math.SingularMatrixException {
        //Ausgabekopf
        System.out.println("Wissenschaftliches Rechnen II");
        System.out.println("Loesung: Serie 3 - Aufgabe 3");
        System.out.println("Copyright (C) 2006 Yves Radunz\n");
        
        //Berechnung und Ausgabe der Ergebnisse.
        for (int n=2;n<11;n+=2){
            //Berechnung der Matrizen
            double[][] matrix  = zielke(n),
                       inv_ex  = inv_zielke(n);
            double[][] inv_num = (new LU(matrix)).inverse();
            
            //Berechnung der Konditionen
            double[][] cond=new double[3][2];
            cond[0][0]=oneNorm(matrix,inv_ex);
            cond[0][1]=oneNorm(matrix,inv_num);
            cond[1][0]=frbNorm(matrix,inv_ex);
            cond[1][1]=frbNorm(matrix,inv_num);
            cond[2][0]=infNorm(matrix,inv_ex);
            cond[2][1]=infNorm(matrix,inv_num);
            
            //Ausgabe in Tabellenform
            String[] condition={"cond_1 ", "cond_f ", "cond_oo"};
            System.out.println("\n------------------------ n = "+n+" ------------------------");
            System.out.println("         exakt                     numerisch");
            //jede Zeile ausgeben
            for (int i=0;i<3;i++)
                System.out.println(condition[i]+"  "+format(cond[i][0])+" "+format(cond[i][1]));
        }
    }
    
    private static double[][] zielke(int n){
        //neue Zielke-Matrix mit a=9998 und der Dimension n erzeugen
        double[][] tmp=new double[n][n];
        for (int i=0;i<n;i++)
            for (int j=0;j<n;j++)
                tmp[i][j]=i!=j?9998: //Wenn i <> j gilt, dann a, ...
                    i%2==0?9997:    //wenn i=j und i gerade ist, dann 9997=a-1
                        9999;      //... und sonst a+1 als Koeffizienten verwenden
        return tmp;
    }
    private static double[][] inv_zielke(int n){
        //exaktes Inverses der Zielke-Matrix mit der Dimension n
        double [][] tmp=new double[n][n];
        for (int i=0;i<n;i++)
            for (int j=0;j<n;j++)
                tmp[i][j]=i!=j?((i+j)%2==0?-9998:9998)
                                             //Wenn i<>j gilt, dann (-1)^{i+j+1}*a, ...
                :i%2==0?-9999:-9997;        //wenn i=j und i gerade, dann 9999=-a-1, 
                                           //... sonst -a+1 als Koeffizient verwenden.
        return tmp;
    }
    private static double oneNorm(double[][] matrix, double[][] invers){
        //1-Norm zur Berechnung verwenden
        double n1=Matrix.oneNorm(matrix),
               n2=Matrix.oneNorm(invers);
        return n1*n2;
    }
    private static double frbNorm(double[][] matrix, double[][] invers){
        //Frobeniusnorm verwenden
        double n1=Matrix.frobeniusNorm(matrix),
               n2=Matrix.frobeniusNorm(invers);
        return n1*n2;
    }
    private static double infNorm(double[][] matrix, double[][] invers){
        //Unenendlich-Norm verwenden
        double n1=Matrix.infinityNorm(matrix),
               n2=Matrix.infinityNorm(invers);
        return n1*n2;
    }
    private static String format(double wert){
        //Zeichenfolgendarstellung von wert auf 25 Zeichen Laenge formatieren
        String tmp=Double.toString(wert);
        while (tmp.length()<25)
            tmp+=" ";
        return tmp;
    }
}