/*
 * Main.java
 *
 * Created on 29. Juni 2006, 12:32
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author radunz
 */
public class Main {
    //Konstanten aus der Aufgabenstellung
    private final static double K=4, D=3, M=10, G=9.81, B=2, Y_0=10, Y_B=1;    
    private final static int[] anz={2, 5, 10};  //Anzahl der Diskretisierungspunkte
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        //Ausgabekopf
        System.out.println("Wissenschaftliches Rechnen II");
        System.out.println("Loesung: Serie 4 - Aufgabe 1");
        System.out.println("Copyright (C) 2006 Yves Radunz\n");
        
        for (int n=0;n<anz.length;n++){
            //Fuer jede der drei Diskretisierungsgenauigkeiten 2, 5 und 10
            //erfolgt eine komplette Berechnung des Gleichungssystems und der
            //dazugehoerigen Loesung.
            
            //Gleichungssystem erzeugen
            double[][] gls=createEqnArray(anz[n]+1,B, Y_0, Y_B);
            
            //Ausgabe...
            System.out.println("\n+-------- N = "+(anz[n]<10?" ":"")+anz[n]+" --------+");
            System.out.println("|                        |");
            
            double ergebnis[] = solve(gls);     //Loesung bestimmen
            for (int i=0;i<=anz[n];i++)         //Loesung ausgeben
                print(ergebnis[i]);
            
            //Ausgabe der Loesung abschliessen
            System.out.println("|                        |");
            System.out.println("+------------------------+\n");
        }
    }
    
    /**
     * Neues Gleichungssystem erstellen.
     * Die letzte Spalte entspricht dem Loesungsvektor.        
     */
    private static double[][]createEqnArray(int n, double b, double y_0, double y_b){
        int N=n-1;                              //Obere Grenze der Indizes
        double[][] gls=new double[n][n+1];      //Array vorbereiten
        double[] x = new double[n];             //x_i vorbereiten
        double h=b/(double)N;                   //Schrittweite berechnen
        
        for (int i=0;i<n;i++)                   //x_i berechnen
            x[i]=(double)i/(double)N;
        
        gls[0][n] = y_0; gls[N][n] = y_b;       //Grenzwerte festlegen
        gls[0][0]   = 1;   gls[N][N]   = 1;     //Erste und letzte Loesungsvariable
        
        for (int i=1;i<N;i++){                  //Die uebrigen Gleichungen
            gls[i][n]  =  -h*h*func_q(x[i]);    //Loesungsvektor
            gls[i][i-1]=-1-h/2*func_s(x[i]);    //Matrixeintraege
            gls[i][i]  = 2+h*h*func_r(x[i]);
            gls[i][i+1]=-1+h/2*func_s(x[i]);
        }
        return gls;
    }
    
    /**
     * Tridiagonales Gleichungssystem loesen
     * Die letzte Spalte enthaelt den Loesungsvektor.
     */
    private static double[] solve(double[][] feld){
        int n=feld.length;                       //Anzahl der Zeilen
        double[] ergebnis=new double[n];
        for (int z=0;z<n-1;z++)
            if (feld[z][z]!=0){
                double faktor=-feld[z+1][z]/feld[z][z];
                                                //Faktor zur Addition mit der
                                                //naechsten Zeile
                feld[z+1][z]=0;                 //Eintrag unter dem aktuellen
                                                //Diagonalelement wird 0
                feld[z+1][z+1]+=feld[z+1][z]*faktor;
                                                //naechsten Diagonaleintrag bestimmen
                feld[z+1][n]+=feld[z][n]*faktor;
                                                //Ergebnisvektor anpassen
            }else{
                //Dieser Fall sollte eigentlich nicht eintreten
                System.out.println("\n! Gleichungssystem nicht eindeutig loesbar.");
                return ergebnis;
            }
        if (feld[n-1][n-1]==0){
            //Dieser Fall sollte eigentlich nicht eintreten
            System.out.println("\n! Gleichungssystem nicht eindeutig loesbar.");
            return ergebnis;
        }
        ergebnis[n-1]=feld[n-1][n]/feld[n-1][n-1];
                                            //letzter Eintrag des Ergebnisvektors
        for (int i=n-2;i>=0;i--)
            ergebnis[i]=(feld[i][n]-ergebnis[i+1]*feld[i][i+1])/feld[i][i];
                                            //die uebrigen Eintrage bestimmen
        return ergebnis;
    }
    private static double func_r(double x){
        //Funktion r(x)
        return -K/M;
    }
    
    private static double func_s(double x){
        //Funktion s(x)
        return -D/M;
    }
    
    private static double func_q(double x){
        //Funktion q(x)
        return -G-func_r(x)*Math.sin(x)-func_s(x)*Math.cos(x);
    }
    
    private static void print(double wert){
        //formatierte Ausgabe
        String tmp=Double.toString(wert);
        while (tmp.length()<21)
            tmp+=" ";
        System.out.println("|  "+tmp+" |");
    }
}
