/*
 * Main.java
 *
 * Created on 11. Juli 2006, 13:35
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import java.awt.*;
import com.imsl.math.*;
import com.imsl.chart.*;

/**
 *
 * @author radunz
 */
public class Main{
    
    private static Ausgabe    out = new Ausgabe();              //Ausgabegraphik
    private static double[][] A   = {{1, 1}, {2, 1}, {1, 2},    //Anzahlen der Atome
                                     {2, 3}, {2, 5}, {2, 4}};   //in einem Molekuel
    private static double[]   b   = {30.006, 44.013, 46.006,    //Messwerte
                                     76.012, 108.010, 92.011};
    private static String[]   T   = {"NO", "N2O", "NO2",        //Bezeichnungen in
                                     "N2O3", "N2O5", "N2O4"};   //der Legende
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        //Berechnung der Abweichungen von den Messwerten
        double[] x={}, Ax={}, r={};       //Variablen initialisieren
        QR A_QR=new QR(A);                //Zerlegung erzeugen
        try{            
            x  = A_QR.solve(b);           //loesen
            Ax = Matrix.multiply(A, x);   //Vergleichswerte berechnen
            //Residuumvektor r = Ax-b
            r  = toVektor(Matrix.subtract(toArray(Ax), toArray(b)));
        }
        catch (SingularMatrixException unused){System.exit(-1);};
        
        //Header (Text-Ausgabe)
        System.out.println("\n  Wissenschaftliches Rechnen II");
        System.out.println("  Loesung: Serie 5 - Aufgabe 2");
        System.out.println("  Copyright (C) 2006 Yves Radunz\n");
        
        //Ausgabe des Vektors
        System.out.println("Eintraege von r:");
        for (int i=0;i<r.length;i++)
            System.out.println(r[i]);        
        System.out.println("\nWeitere Ausgaben => siehe Graphikfenster\n");
        
        //Abstaende (bzw. Betraege) berechnen und skalieren:
        for (int i=0;i<r.length;i++)
            r[i]=Math.abs(r[i])*1e3;
        out.print(r);         //graphische Ausgabe
    }
    
    /**
     * zweidimensionales Array aus einem Vektor erzeugen
     */
    private static double[][] toArray(double[] Vektor){
        double[][] tmp={Vektor};
        return tmp;
    }
    
    /**
     * Vektor aus einem zweidimensionalen Array erzeugen
     */
    private static double[] toVektor(double[][] Array){
        return Array[0];
    }
    
    /**
     * Klasse zur Ausgabe einer Graphik
     */
    private static class Ausgabe extends JFrameChart{
        /**
         * Erstellt neue Instanz der Klasse Ausgabe
         */
        public Ausgabe() {
            super();
            setSize(640, 480);
        }
        
        /**
         * die berechneten Werte ausgeben
         */
        public void print(double[] werte){
            //Einige Vorbereitungen
            double[][] x = new double[werte.length][4],    //Speicher fuer die
                       y = new double[werte.length][4];    //Ecken der Rechtecke
            Chart chart = getChart();                      //Graphik
            AxisXY axis = new AxisXY(chart);               //Koordinaten
            
            //Rechteckige Graphen erzeugen
            for (int i=0;i<werte.length;i++){
                x[i][0]=i-.45; x[i][2]=i+.45;   //Ecken der Rechtecke festlegen
                x[i][1]=i-.45; x[i][3]=i+.45;
                y[i][0]=0; y[i][1]=werte[i];
                y[i][3]=0; y[i][2]=werte[i];
                
                Data points = new Data(axis, x[i], y[i]);  //Rechtecke erzeugen
                //Farbe der Rechtecke festlegen
                points.setFillColor(new Color((1-i%2)*255,            //rot
                                              (((1+i)%4)>>1)*255,     //gruen
                                              (((i+1)%8)>>2)*255      //blau
                                             ));
                points.setTitle(T[i]);                //Bezeichnungen festlegen
                points.setDataType(4);                //ausgefuellt zeichnen
            }
            
            //Anmerkung zur Skalierung der Abweichung erzeugen
            Data anmerkung = new Data(axis, new double[0], new double[0]);
            anmerkung.setTitle("Abweichung\nder Massen\nin 0.001");
            anmerkung.setLineColor("white");

            //Ausgabe
            (chart.getLegend()).setPaint(true);  //Legende erzeugen
            setVisible(true);                    //auf dem Bildschirm darstellen
        }        
    }
}